

class MyPlayer(object):
    """
    Docstring for MyPlayer
    """

    def __init__(self, my_color, opponent_color):
        self.name = 'username'                   # TODO: Fill in your username
        self.my_color = my_color
        self.opponent_color = opponent_color

    def move(self, board):                                                        # TODO: Write your method here.
        print(self.get_all_valid_moves(board, active_color=self.my_color))        # Example of usage for method.
        print(self.get_all_valid_moves(board, active_color=self.opponent_color))
        return (0, 0)

    def __is_correct_move(self, move, board, board_size, active_color):
        dx = [-1, -1, -1, 0, 1, 1, 1, 0]
        dy = [-1, 0, 1, 1, 1, 0, -1, -1]
        for i in range(len(dx)):
            if self.__confirm_direction(move, dx[i], dy[i], board, board_size, active_color):
                return True
        return False

    def __confirm_direction(self, move, dx, dy, board, board_size, active_color):
        posx = move[0]+dx
        posy = move[1]+dy
        passive_color = (active_color+1) % 2
        if (posx >= 0) and (posx < board_size) and (posy >= 0) and (posy < board_size):
            if board[posx][posy] == passive_color:
                while (posx >= 0) and (posx <= (board_size-1)) and (posy >= 0) and (posy <= (board_size-1)):
                    posx += dx
                    posy += dy
                    if (posx >= 0) and (posx < board_size) and (posy >= 0) and (posy < board_size):
                        if board[posx][posy] == -1:
                            return False
                        if board[posx][posy] == active_color:
                            return True

        return False

    def get_all_valid_moves(self, board, active_color):
        """
        Returns all valid moves for a given board setup with active_color player
        trying to do the move.
        :param board: board setup list
        :param active_color: 0 or 1
        :return: list or None
        """
        board_size = len(board)
        valid_moves = []
        for x in range(board_size):
            for y in range(board_size):
                if (board[x][y] == -1) and self.__is_correct_move([x, y], board, board_size, active_color):
                    valid_moves.append((x, y))

        if len(valid_moves) <= 0:
            print('No possible move for ' + str(active_color))
            return None
        return valid_moves

